[Setup]
AppId={{5A2BC38A-406C-4A5B-BF45-6991F9A05325}
AppName=PeaZip
AppVerName=PeaZip 2.6.3
AppPublisher=Giorgio Tani
AppPublisherURL=http://peazip.sourceforge.net/
AppSupportURL=http://peazip.sourceforge.net/
AppUpdatesURL=http://peazip.sourceforge.net/
DefaultDirName={pf}\PeaZip
DisableDirPage=no
DefaultGroupName=PeaZip
DisableProgramGroupPage=yes
LicenseFile=C:\peazip-2.6.3.WINDOWS\copying.txt
InfoBeforeFile=C:\peazip-2.6.3.WINDOWS\readme_Win32.txt
OutputDir=C:\
OutputBaseFilename=peazip-2.6.3.WINDOWS
SetupIconFile=PeaZip_installer.ico
Compression=lzma
SolidCompression=yes
ChangesAssociations=yes

[Registry]
Root: HKCR; Subkey: ".001"; ValueType: string; ValueName: ""; ValueData: "001"; Flags: uninsdeletevalue
Root: HKCR; Subkey: "001"; ValueType: string; ValueName: ""; ValueData: "Split file"; Flags: uninsdeletekey
Root: HKCR; Subkey: "001\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\RES\ICONS\PEAZIP_BLOCK.ICO,0"
Root: HKCR; Subkey: "001\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\PEAZIP.EXE"" ""%1"""

Root: HKCR; Subkey: ".pea"; ValueType: string; ValueName: ""; ValueData: "PEA"; Flags: uninsdeletevalue
Root: HKCR; Subkey: "PEA"; ValueType: string; ValueName: ""; ValueData: "PEA archive"; Flags: uninsdeletekey
Root: HKCR; Subkey: "PEA\DefaultIcon"; ValueType: string; ValueName: ""; ValueData: "{app}\RES\ICONS\PEAZIP.ICO,0"
Root: HKCR; Subkey: "PEA\shell\open\command"; ValueType: string; ValueName: ""; ValueData: """{app}\PEAZIP.EXE"" ""%1"""

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}";
Name: "quicklaunchicon"; Description: "{cm:CreateQuickLaunchIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked

[Files]
Source: "C:\peazip-2.6.3.WINDOWS\peazip.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "C:\peazip-2.6.3.WINDOWS\res\*"; DestDir: "{app}\res"; Flags: ignoreversion recursesubdirs createallsubdirs
Source: "C:\peazip-2.6.3.WINDOWS\copying.txt"; DestDir: "{app}"; Flags: ignoreversion
Source: "C:\peazip-2.6.3.WINDOWS\readme_Win32.txt"; DestDir: "{app}"; Flags: ignoreversion
Source: "C:\peazip-2.6.3.WINDOWS\peazip_help.pdf"; DestDir: "{app}"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[INI]
Filename: "{app}\peazip.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://peazip.sourceforge.net/"

[Icons]
Name: "{group}\PeaZip"; Filename: "{app}\peazip.exe"
Name: "{group}\{cm:ProgramOnTheWeb,PeaZip}"; Filename: "{app}\peazip.url"
Name: "{group}\{cm:UninstallProgram,PeaZip}"; Filename: "{uninstallexe}"
Name: "{userdesktop}\PeaZip"; Filename: "{app}\peazip.exe"; Tasks: desktopicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\PeaZip"; Filename: "{app}\peazip.exe"; Tasks: quicklaunchicon

[Run]
;Filename: "{app}\peazip.exe"; Description: "{cm:LaunchProgram,PeaZip}"; Flags: nowait postinstall skipifsilent
;temporarily deactivated since this works correctly (using current user's profile) only for Vista or more recent systems

[UninstallDelete]
Type: files; Name: "{app}\peazip.url"

[CustomMessages]
				Associations_2__Caption=File associations
				Associations_2__Description=Set file types to be associated with PeaZip
				Associations_2__Labelfull1_Caption0=Read/write supported types:
				Associations_2__Labelread1_Caption0=Read supported types:
				Associations_2__cb7z_Caption0=7Z
				Associations_2__cbarc_Caption0=ARC/WRC
				Associations_2__cbbz2_Caption0=BZ2
				Associations_2__cbgz_Caption0=GZ
				Associations_2__cbpaq8_Caption0=PAQ/LPAQ
				Associations_2__cbquad_Caption0=QUAD/BALZ
				Associations_2__cbtar_Caption0=TAR
				Associations_2__cbzip_Caption0=ZIP
				Associations_2__cbfullnone_Caption0=None of the above group (override selection)
				Associations_2__cbarj_Caption0=ARJ
				Associations_2__cbcab_Caption0=CAB
				Associations_2__cblinux_Caption0=Linux (DEB, RPM, PET/PUP, SLP)
				Associations_2__cbiso_Caption0=ISO, UDF
				Associations_2__cblha_Caption0=LHA
				Associations_2__cblzh_Caption0=LZH
				Associations_2__cbrar_Caption0=RAR
				Associations_2__cbcpio_Caption0=CPIO, Z
				Associations_2__cbreadnone_Caption0=None of the above group (override selection)
				Associations_2__cbace_Caption0=ACE
				Associations_2__cbMac_Caption0=Mac (DMG/HFS)
				Links_Caption=SendTo
				Links_Description=Create links to most used functions in SendTo men
				Links_Label1fun_Caption0=PeaZip links in SendTo menu:
				Links_cbfunadd2archive_Caption0=+ + Add to archive
				Links_cbfunadd2archive_Hint0=Send files and folders to PeaZip to be archived
				Links_cbfunext2here_Caption0=- Extract here
				Links_cbfunext2here_Hint0=Extract archive(s) to their respective path(s)
				Links_cbfun7z_Caption0=+ Add to 7Z
				Links_cbfun7z_Hint0=Directly add input to a 7Z archive
				Links_cbfunzip_Caption0=+ Add to ZIP
				Links_cbfunzip_Hint0=Directly add input to a ZIP archive
				Links_cbfunsfx_Caption0=+ Add to sfx
				Links_cbfunsfx_Hint0=Directly send input to a 7z-compressed self extracting archive ('sfx)
				Links_cbfunsplit_Caption0=+ Split file
				Links_cbfunsplit_Hint0=Directly split a single file in volumes of given size
				Links_cbfunnone_Caption0=None of the optional ones (override selection)
				Links_cbfunopen_Caption0=- - Open with PeaZip
				Links_cbfunopen_Hint0=Open archive(s) in PeaZip
				Links_cbfunext2folder_Caption0=- Extract here (in new folder)
				Links_cbfunext2folder_Hint0=Extract archive(s) to their respective path(s), in a fresh new folder
				Links_cbfun7zs_Caption0=+ Add to separate 7Z
				Links_cbfun7zs_Hint0=Directly add each input to a separate 7Z archive
				Links_cbfunzips_Caption0=+ Add to separate ZIP
				Links_cbfunzips_Hint0=Directly add each input to a separate ZIP archive
				Links_cbfunencrypt_Caption0=+ Encrypt
				Links_cbfunencrypt_Hint0=Directly send files and folders to an encrypted PEA archive
				Links_cbfuntest_Caption0=- Test archive(s)
				Links_cbfuntest_Hint0=Perform integrity test on given archive(s)
				Links_cbfunzipmail_Caption0=+ Add to ZIP and mail
				Links_cbfunzipmail_Hint0=Directly add input to a ZIP archive and attach it to a mail (req'uires Outlook)
				Links_cbfun7zmail_Caption0=+ Add to 7Z and mail
				Links_cbfun7zmail_Hint0=Directly add input to a 7Z archive and attach it to a mail (requ'ires Outlook)
				Links_cbfunsfxmail_Caption0=+ Add to sfx and mail
				Links_cbfunsfxmail_Hint0=Directly add input to a self extracting archive and attach it to' a mail (requires Outlook)
				Links_cbfunwipe_Caption0=+ Secure delete
				Links_cbfunwipe_Hint0=Erase (securely delete) files
				Links_cbfunext2to_Caption0=- Extract...
				Links_cbfunext2to_Hint0=Extract archive(s): allows to set path, password and other options
				context_Caption=Context menu
				context_Description=Create links to most used functions in Context menu
				context_Label1context_Caption0=PeaZip links in Context menu:
				context_cbcontextadd2archive_Caption0=+ Add to separate archive(s)
				context_cbcontextadd2archive_Hint0=Add a single item to a new archive
				context_cbcontextext2here_Caption0=- Extract here
				context_cbcontextext2here_Hint0=Extract archive(s) in their respective path(s)
				context_cbcontextsplit_Caption0=+ Split file
				context_cbcontextsplit_Hint0=Directly split a single file in volumes of given size
				context_cbcontextnone_Caption0=None of the above group (override selection)
				context_cbcontextopen_Caption0=[file] - Open with PeaZip
				context_cbcontextopen_Hint0=Open archive(s) in PeaZip
				context_cbcontextext2folder_Caption0=- Extract here (in new folder)
				context_cbcontextext2folder_Hint0=Extract archive(s) in their respective path(s), in a fresh new folder
				context_cbcontext7zs_Caption0=+ Add to separate 7Z
				context_cbcontext7zs_Hint0=Directly add each input to a separate 7Z archive
				context_cbcontextzips_Caption0=+ Add to separate ZIP
				context_cbcontextzips_Hint0=Directly add each input to a separate ZIP archive
				context_cbcontexttest_Caption0=- Test archive(s)
				context_cbcontexttest_Hint0=Perform integrity test on given archive(s)
				context_cbcontext2to_Caption0=- Extract...
				context_cbcontext2to_Hint0=Extract archive(s): allows to set path, password and other parameters
				context_cbcontextwipe_Caption0=+ Secure delete
				context_cbcontextwipe_Hint0=Erase (securely delete) files
				context_cbcontextbrowse_Caption0=[folder] - Browse with PeaZip
    		context_cbcontextbrowse_Hint0=Browse disks and folders with PeaZip

[Code]
var
  MyProgChecked: Boolean;
  MyProgCheckResult: Boolean;
  FinishedInstall: Boolean;
				  Labelfull1: TLabel;
				  Bevel1: TBevel;
				  Labelread1: TLabel;
				  Bevel2: TBevel;
				  cb7z: TCheckBox;
				  cbarc: TCheckBox;
				  cbbz2: TCheckBox;
				  cbgz: TCheckBox;
				  cbpaq8: TCheckBox;
				  cbquad: TCheckBox;
				  cbtar: TCheckBox;
				  cbzip: TCheckBox;
				  cbfullnone: TCheckBox;
				  cbarj: TCheckBox;
				  cbcab: TCheckBox;
				  cblinux: TCheckBox;
				  cbiso: TCheckBox;
				  cblha: TCheckBox;
				  cblzh: TCheckBox;
				  cbrar: TCheckBox;
				  cbcpio: TCheckBox;
				  cbreadnone: TCheckBox;
				  cbace: TCheckBox;
 				  cbMac: TCheckBox;
				  Label1fun: TLabel;
				  Bevel1fun: TBevel;
				  cbfunadd2archive: TCheckBox;
				  cbfunext2here: TCheckBox;
				  cbfun7z: TCheckBox;
				  cbfunzip: TCheckBox;
				  cbfunsfx: TCheckBox;
				  cbfunsplit: TCheckBox;
				  cbfunnone: TCheckBox;
				  cbfunopen: TCheckBox;
				  cbfunext2folder: TCheckBox;
				  cbfun7zs: TCheckBox;
				  cbfunzips: TCheckBox;
				  cbfunencrypt: TCheckBox;
				  cbfuntest: TCheckBox;
				  cbfunzipmail: TCheckBox;
				  cbfun7zmail: TCheckBox;
				  cbfunsfxmail: TCheckBox;
				  cbfunwipe: TCheckBox;
				  cbfunext2to: TCheckBox;
				  Label1context: TLabel;
				  Bevel1context: TBevel;
				  cbcontextadd2archive: TCheckBox;
				  cbcontextext2here: TCheckBox;
				  cbcontextsplit: TCheckBox;
				  cbcontextnone: TCheckBox;
				  cbcontextopen: TCheckBox;
				  cbcontextext2folder: TCheckBox;
				  cbcontext7zs: TCheckBox;
				  cbcontextzips: TCheckBox;
				  cbcontexttest: TCheckBox;
				  cbcontext2to: TCheckBox;
				  cbcontextwipe: TCheckBox;
 				  cbcontextbrowse: TCheckBox;
				
				{ Associations_2__Activate }
				
				procedure Associations_2__Activate(Page: TWizardPage);
				begin
				  // enter code here...
				end;
				
				{ Associations_2__ShouldSkipPage }
				
				function Associations_2__ShouldSkipPage(Page: TWizardPage): Boolean;
				begin
				  Result := False;
				end;
				
				{ Associations_2__BackButtonClick }
				
				function Associations_2__BackButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ Associations_2__NextkButtonClick }
				
				function Associations_2__NextButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ Associations_2__CancelButtonClick }
				
				procedure Associations_2__CancelButtonClick(Page: TWizardPage; var Cancel, Confirm: Boolean);
				begin
				  // enter code here...
				end;
				
				{ Associations_2__CreatePage }
				
				function Associations_2__CreatePage(PreviousPageId: Integer): Integer;
				var
				  Page: TWizardPage;
				begin
				  Page := CreateCustomPage(
				    PreviousPageId,
				    ExpandConstant('{cm:Associations_2__Caption}'),
				    ExpandConstant('{cm:Associations_2__Description}')
				  );
				
				{ Labelfull1 }
				  Labelfull1 := TLabel.Create(Page);
				  with Labelfull1 do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__Labelfull1_Caption0}');
				    Left := ScaleX(0);
				    Top := ScaleY(0);
				    Width := ScaleX(163);
				    Height := ScaleY(13);
				    Font.Color := -16777208;
				    Font.Height := ScaleY(-11);
				    Font.Name := 'Tahoma';
				    Font.Style := [fsBold];
				    WordWrap := True;
				  end;
				
				  { Bevel1 }
				  Bevel1 := TBevel.Create(Page);
				  with Bevel1 do
				  begin
				    Parent := Page.Surface;
				    Left := ScaleX(8);
				    Top := ScaleY(20);
				    Width := ScaleX(396);
				    Height := ScaleY(52);
				  end;
				
				  { Labelread1 }
				  Labelread1 := TLabel.Create(Page);
				  with Labelread1 do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__Labelread1_Caption0}');
				    Left := ScaleX(0);
				    Top := ScaleY(112);
				    Width := ScaleX(128);
				    Height := ScaleY(13);
				    Font.Color := -16777208;
				    Font.Height := ScaleY(-11);
				    Font.Name := 'Tahoma';
				    Font.Style := [fsBold];
				    WordWrap := True;
				  end;
				
				  { Bevel2 }
				  Bevel2 := TBevel.Create(Page);
				  with Bevel2 do
				  begin
				    Parent := Page.Surface;
				    Left := ScaleX(8);
				    Top := ScaleY(132);
				    Width := ScaleX(396);
				    Height := ScaleY(78);
				  end;
				
				  { cb7z }
				  cb7z := TCheckBox.Create(Page);
				  with cb7z do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cb7z_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(24);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 0;
				  end;

				  { cbarc }
				  cbarc := TCheckBox.Create(Page);
				  with cbarc do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbarc_Caption0}');
				    Left := ScaleX(116);
				    Top := ScaleY(24);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 1;
				  end;
				
				  { cbbz2 }
				  cbbz2 := TCheckBox.Create(Page);
				  with cbbz2 do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbbz2_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(24);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 2;
				  end;
				
				  { cbgz }
				  cbgz := TCheckBox.Create(Page);
				  with cbgz do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbgz_Caption0}');
				    Left := ScaleX(316);
				    Top := ScaleY(24);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 3;
				  end;
				
				  { cbpaq8 }
				  cbpaq8 := TCheckBox.Create(Page);
				  with cbpaq8 do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbpaq8_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(48);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 4;
				  end;
				
				  { cbquad }
				  cbquad := TCheckBox.Create(Page);
				  with cbquad do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbquad_Caption0}');
				    Left := ScaleX(116);
				    Top := ScaleY(48);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 5;
				  end;
				
				  { cbtar }
				  cbtar := TCheckBox.Create(Page);
				  with cbtar do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbtar_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(48);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 6;
				  end;
				
				  { cbzip }
				  cbzip := TCheckBox.Create(Page);
				  with cbzip do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbzip_Caption0}');
				    Left := ScaleX(316);
				    Top := ScaleY(48);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 7;
				  end;
				
				  { cbfullnone }
				  cbfullnone := TCheckBox.Create(Page);
				  with cbfullnone do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbfullnone_Caption0}');
				    Left := ScaleX(8);
				    Top := ScaleY(74);
				    Width := ScaleX(321);
				    Height := ScaleY(25);
				    TabOrder := 8;
				  end;
				
				  { cbarj }
				  cbarj := TCheckBox.Create(Page);
				  with cbarj do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbarj_Caption0}');
				    Left := ScaleX(116);
				    Top := ScaleY(136);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 9;
				  end;
				
				  { cbcab }
				  cbcab := TCheckBox.Create(Page);
				  with cbcab do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbcab_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(136);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 10;
				  end;
				
				  { cblinux }
				  cblinux := TCheckBox.Create(Page);
				  with cblinux do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cblinux_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(184);
				    Width := ScaleX(200);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 11;
				  end;
				  
				  { cbMac }
				  cbMac := TCheckBox.Create(Page);
				  with cbMac do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbMac_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(184);
				    Width := ScaleX(200);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 19;
				  end;
				
				  { cbiso }
				  cbiso := TCheckBox.Create(Page);
				  with cbiso do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbiso_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(160);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 12;
				  end;
				
				  { cblha }
				  cblha := TCheckBox.Create(Page);
				  with cblha do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cblha_Caption0}');
				    Left := ScaleX(116);
				    Top := ScaleY(160);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 13;
				  end;
				
				  { cblzh }
				  cblzh := TCheckBox.Create(Page);
				  with cblzh do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cblzh_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(160);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 14;
				  end;
				
				  { cbrar }
				  cbrar := TCheckBox.Create(Page);
				  with cbrar do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbrar_Caption0}');
				    Left := ScaleX(316);
				    Top := ScaleY(160);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 15;
				  end;
				
				  { cbcpio }
				  cbcpio := TCheckBox.Create(Page);
				  with cbcpio do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbcpio_Caption0}');
				    Left := ScaleX(316);
				    Top := ScaleY(136);
				    Width := ScaleX(73);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 16;
				  end;
				
				  { cbreadnone }
				  cbreadnone := TCheckBox.Create(Page);
				  with cbreadnone do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbreadnone_Caption0}');
				    Left := ScaleX(8);
				    Top := ScaleY(210);
				    Width := ScaleX(329);
				    Height := ScaleY(25);
				    TabOrder := 17;
				  end;
				
				  { cbace }
				  cbace := TCheckBox.Create(Page);
				  with cbace do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Associations_2__cbace_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(136);
				    Width := ScaleX(81);
				    Height := ScaleY(17);
				    Checked := True;
				    State := cbChecked;
				    TabOrder := 18;
				  end;
				
				  with Page do
				  begin
				    OnActivate := @Associations_2__Activate;
				    OnShouldSkipPage := @Associations_2__ShouldSkipPage;
				    OnBackButtonClick := @Associations_2__BackButtonClick;
				    OnNextButtonClick := @Associations_2__NextButtonClick;
				    OnCancelButtonClick := @Associations_2__CancelButtonClick;
				  end;
				
				  Result := Page.ID;
				end;
				
				{ Links_Activate }
				
				procedure Links_Activate(Page: TWizardPage);
				begin
				  // enter code here...
				end;
				
				{ Links_ShouldSkipPage }
				
				function Links_ShouldSkipPage(Page: TWizardPage): Boolean;
				begin
				  Result := False;
				end;
				
				{ Links_BackButtonClick }
				
				function Links_BackButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ Links_NextkButtonClick }
				
				function Links_NextButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ Links_CancelButtonClick }
				
				procedure Links_CancelButtonClick(Page: TWizardPage; var Cancel, Confirm: Boolean);
				begin
				  // enter code here...
				end;
				
				{ Links_CreatePage }
				
				function Links_CreatePage(PreviousPageId: Integer): Integer;
				var
				  Page: TWizardPage;
				begin
				  Page := CreateCustomPage(
				    PreviousPageId,
				    ExpandConstant('{cm:Links_Caption}'),
				    ExpandConstant('{cm:Links_Description}')
				  );
				
				{ Label1fun }
				  Label1fun := TLabel.Create(Page);
				  with Label1fun do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_Label1fun_Caption0}');
				    Left := ScaleX(0);
				    Top := ScaleY(0);
				    Width := ScaleX(163);
				    Height := ScaleY(13);
				    Font.Color := -16777208;
				    Font.Height := ScaleY(-11);
				    Font.Name := 'Tahoma';
				    Font.Style := [fsBold];
				    WordWrap := True;
				  end;
				
				  { Bevel1fun }
				  Bevel1fun := TBevel.Create(Page);
				  with Bevel1fun do
				  begin
				    Parent := Page.Surface;
				    Left := ScaleX(8);
				    Top := ScaleY(40);
				    Width := ScaleX(401);
				    Height := ScaleY(170);
				  end;
				
				  { cbfunadd2archive }
				  cbfunadd2archive := TCheckBox.Create(Page);
				  with cbfunadd2archive do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunadd2archive_Caption0}');
				    Left := ScaleX(8);
				    Top := ScaleY(20);
				    Width := ScaleX(145);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunadd2archive_Hint0}');
				    Checked := True;
				    Enabled := False;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 0;
				  end;
				
				  { cbfunext2here }
				  cbfunext2here := TCheckBox.Create(Page);
				  with cbfunext2here do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunext2here_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(44);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunext2here_Hint0}');
				    ShowHint := True;
				    //State := cbChecked;
				    TabOrder := 1;
				  end;
				
				  { cbfun7z }
				  cbfun7z := TCheckBox.Create(Page);
				  with cbfun7z do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfun7z_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(44);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfun7z_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 2;
				  end;
				
				  { cbfunzip }
				  cbfunzip := TCheckBox.Create(Page);
				  with cbfunzip do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunzip_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(104);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunzip_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 3;
				  end;
				
				  { cbfunsfx }
				  cbfunsfx := TCheckBox.Create(Page);
				  with cbfunsfx do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunsfx_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(144);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunsfx_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 4;
				  end;
				
				  { cbfunsplit }
				  cbfunsplit := TCheckBox.Create(Page);
				  with cbfunsplit do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunsplit_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(184);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunsplit_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 5;
				  end;
				
				  { cbfunnone }
				  cbfunnone := TCheckBox.Create(Page);
				  with cbfunnone do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunnone_Caption0}');
				    Left := ScaleX(8);
				    Top := ScaleY(210);
				    Width := ScaleX(321);
				    Height := ScaleY(25);
				    TabOrder := 6;
				  end;
				
				  { cbfunopen }
				  cbfunopen := TCheckBox.Create(Page);
				  with cbfunopen do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunopen_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(20);
				    Width := ScaleX(145);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunopen_Hint0}');
				    Checked := True;
				    Enabled := False;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 7;
				  end;
				
				  { cbfunext2folder }
				  cbfunext2folder := TCheckBox.Create(Page);
				  with cbfunext2folder do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunext2folder_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(64);
				    Width := ScaleX(180);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunext2folder_Hint0}');
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 8;
				  end;
				
				  { cbfun7zs }
				  cbfun7zs := TCheckBox.Create(Page);
				  with cbfun7zs do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfun7zs_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(64);
				    Width := ScaleX(161);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfun7zs_Hint0}');
				    ShowHint := True;
				    TabOrder := 9;
				  end;
				
				  { cbfunzips }
				  cbfunzips := TCheckBox.Create(Page);
				  with cbfunzips do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunzips_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(124);
				    Width := ScaleX(153);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunzips_Hint0}');
				    ShowHint := True;
				    TabOrder := 10;
				  end;
				
				  { cbfunencrypt }
				  cbfunencrypt := TCheckBox.Create(Page);
				  with cbfunencrypt do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunencrypt_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(164);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunencrypt_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 11;
				  end;
				
				  { cbfuntest }
				  cbfuntest := TCheckBox.Create(Page);
				  with cbfuntest do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfuntest_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(124);
				    Width := ScaleX(185);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfuntest_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 12;
				  end;
				
				  { cbfunzipmail }
				  cbfunzipmail := TCheckBox.Create(Page);
				  with cbfunzipmail do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunzipmail_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(144);
				    Width := ScaleX(153);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunzipmail_Hint0}');
				    ShowHint := True;
				    TabOrder := 13;
				  end;
				
				  { cbfun7zmail }
				  cbfun7zmail := TCheckBox.Create(Page);
				  with cbfun7zmail do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfun7zmail_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(84);
				    Width := ScaleX(161);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfun7zmail_Hint0}');
				    ShowHint := True;
				    TabOrder := 14;
				  end;
				
				  { cbfunsfxmail }
				  cbfunsfxmail := TCheckBox.Create(Page);
				  with cbfunsfxmail do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunsfxmail_Caption0}');
				    Left := ScaleX(216);
				    Top := ScaleY(164);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunsfxmail_Hint0}');
				    ShowHint := True;
				    TabOrder := 15;
				  end;
				
				  { cbfunwipe }
				  cbfunwipe := TCheckBox.Create(Page);
				  with cbfunwipe do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunwipe_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(184);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunwipe_Hint0}');
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 16;
				  end;
				
				  { cbfunext2to }
				  cbfunext2to := TCheckBox.Create(Page);
				  with cbfunext2to do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:Links_cbfunext2to_Caption0}');
				    Left := ScaleX(200);
				    Top := ScaleY(84);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:Links_cbfunext2to_Hint0}');
				    ShowHint := True;
				    TabOrder := 17;
				  end;
					
				  with Page do
				  begin
				    OnActivate := @Links_Activate;
				    OnShouldSkipPage := @Links_ShouldSkipPage;
				    OnBackButtonClick := @Links_BackButtonClick;
				    OnNextButtonClick := @Links_NextButtonClick;
				    OnCancelButtonClick := @Links_CancelButtonClick;
				  end;
				
				  Result := Page.ID;
				end;

				{ context_Activate }
				
				procedure context_Activate(Page: TWizardPage);
				begin
				  // enter code here...
				end;
				
				{ context_ShouldSkipPage }
				
				function context_ShouldSkipPage(Page: TWizardPage): Boolean;
				begin
				  Result := False;
				end;
				
				{ context_BackButtonClick }
				
				function context_BackButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ context_NextkButtonClick }
				
				function context_NextButtonClick(Page: TWizardPage): Boolean;
				begin
				  Result := True;
				end;
				
				{ context_CancelButtonClick }
				
				procedure context_CancelButtonClick(Page: TWizardPage; var Cancel, Confirm: Boolean);
				begin
				  // enter code here...
				end;
				
				{ context_CreatePage }
				
				function context_CreatePage(PreviousPageId: Integer): Integer;
				var
				  Page: TWizardPage;
				begin
				  Page := CreateCustomPage(
				    PreviousPageId,
				    ExpandConstant('{cm:context_Caption}'),
				    ExpandConstant('{cm:context_Description}')
				  );
				
				{ Label1context }
				  Label1context := TLabel.Create(Page);
				  with Label1context do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_Label1context_Caption0}');
				    Left := ScaleX(0);
				    Top := ScaleY(0);
				    Width := ScaleX(166);
				    Height := ScaleY(13);
				    Font.Color := -16777208;
				    Font.Height := ScaleY(-11);
				    Font.Name := 'Tahoma';
				    Font.Style := [fsBold];
				    WordWrap := True;
				  end;
				
				  { Bevel1context }
				  Bevel1context := TBevel.Create(Page);
				  with Bevel1context do
				  begin
				    Parent := Page.Surface;
				    Left := ScaleX(8);
				    Top := ScaleY(24);
				    Width := ScaleX(396);
				    Height := ScaleY(170);
				  end;
				
				  { cbcontextadd2archive }
				  cbcontextadd2archive := TCheckBox.Create(Page);
				  with cbcontextadd2archive do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextadd2archive_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(28);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextadd2archive_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 0;
				  end;
				
				  { cbcontextext2here }
				  cbcontextext2here := TCheckBox.Create(Page);
				  with cbcontextext2here do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextext2here_Caption0}');
				    Left := ScaleX(208);
				    Top := ScaleY(76);
				    Width := ScaleX(193);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextext2here_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 1;
				  end;
				
				  { cbcontextsplit }
				  cbcontextsplit := TCheckBox.Create(Page);
				  with cbcontextsplit do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextsplit_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(100);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextsplit_Hint0}');
				    ShowHint := True;
				    TabOrder := 2;
				  end;
				
				  { cbcontextnone }
				  cbcontextnone := TCheckBox.Create(Page);
				  with cbcontextnone do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextnone_Caption0}');
				    Left := ScaleX(8);
				    Top := ScaleY(196);
				    Width := ScaleX(321);
				    Height := ScaleY(25);
				    TabOrder := 3;
				  end;
				
				  { cbcontextopen }
				  cbcontextopen := TCheckBox.Create(Page);
				  with cbcontextopen do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextopen_Caption0}');
				    Left := ScaleX(208);
				    Top := ScaleY(28);
				    Width := ScaleX(145);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextopen_Hint0}');
				    ShowHint := True;
				    TabOrder := 4;
				  end;
				
				  { cbcontextext2folder }
				  cbcontextext2folder := TCheckBox.Create(Page);
				  with cbcontextext2folder do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextext2folder_Caption0}');
				    Left := ScaleX(224);
				    Top := ScaleY(100);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextext2folder_Hint0}');
				    ShowHint := True;
				    TabOrder := 5;
				  end;
				
				  { cbcontext7zs }
				  cbcontext7zs := TCheckBox.Create(Page);
				  with cbcontext7zs do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontext7zs_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(52);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontext7zs_Hint0}');
				    ShowHint := True;
				    TabOrder := 6;
				  end;
				
				  { cbcontextzips }
				  cbcontextzips := TCheckBox.Create(Page);
				  with cbcontextzips do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextzips_Caption0}');
				    Left := ScaleX(32);
				    Top := ScaleY(76);
				    Width := ScaleX(169);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextzips_Hint0}');
				    ShowHint := True;
				    TabOrder := 7;
				  end;
				
				  { cbcontexttest }
				  cbcontexttest := TCheckBox.Create(Page);
				  with cbcontexttest do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontexttest_Caption0}');
				    Left := ScaleX(208);
				    Top := ScaleY(148);
				    Width := ScaleX(185);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontexttest_Hint0}');
				    ShowHint := True;
				    TabOrder := 8;
				  end;
				
				  { cbcontext2to }
				  cbcontext2to := TCheckBox.Create(Page);
				  with cbcontext2to do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontext2to_Caption0}');
				    Left := ScaleX(208);
				    Top := ScaleY(124);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontext2to_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 9;
				  end;
				
				  { cbcontextwipe }
				  cbcontextwipe := TCheckBox.Create(Page);
				  with cbcontextwipe do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextwipe_Caption0}');
				    Left := ScaleX(16);
				    Top := ScaleY(124);
				    Width := ScaleX(177);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextwipe_Hint0}');
				    ShowHint := True;
				    TabOrder := 10;
				  end;
				
				  { cbcontextbrowse }
				  cbcontextbrowse := TCheckBox.Create(Page);
				  with cbcontextbrowse do
				  begin
				    Parent := Page.Surface;
				    Caption := ExpandConstant('{cm:context_cbcontextbrowse_Caption0}');
				    Left := ScaleX(208);
				    Top := ScaleY(52);
				    Width := ScaleX(193);
				    Height := ScaleY(17);
				    Hint := ExpandConstant('{cm:context_cbcontextbrowse_Hint0}');
				    Checked := True;
				    ShowHint := True;
				    State := cbChecked;
				    TabOrder := 11;
				  end;
				
				  with Page do
				  begin
				    OnActivate := @context_Activate;
				    OnShouldSkipPage := @context_ShouldSkipPage;
				    OnBackButtonClick := @context_BackButtonClick;
				    OnNextButtonClick := @context_NextButtonClick;
				    OnCancelButtonClick := @context_CancelButtonClick;
				  end;
				
				  Result := Page.ID;
				end;
				
				{ Links_InitializeWizard }
				
				procedure InitializeWizard();
				begin
				  Associations_2__CreatePage(wpSelectDir);//InfoBefore);
				  Links_CreatePage(wpSelectDir);
				  context_CreatePage(wpSelectDir);
				end;

procedure clearlinks;
begin
deletefile(expandconstant('{sendto}')+'\+ + Add to archive.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to .7Z.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to .7Z and send by mail.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to separate .7Z.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to .ZIP.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to .ZIP and send by mail.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to separate .ZIP.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to self-extracting archive.lnk');
deletefile(expandconstant('{sendto}')+'\+ Add to sfx and send by mail.lnk');
deletefile(expandconstant('{sendto}')+'\+ Encrypt.lnk');
deletefile(expandconstant('{sendto}')+'\+ Split file.lnk');
deletefile(expandconstant('{sendto}')+'\+ Secure delete.lnk');
deletefile(expandconstant('{sendto}')+'\- Extract here.lnk');
deletefile(expandconstant('{sendto}')+'\- Extract....lnk');
deletefile(expandconstant('{sendto}')+'\- Extract here (in new folder).lnk');
deletefile(expandconstant('{sendto}')+'\- - Open with PeaZip.lnk');
deletefile(expandconstant('{sendto}')+'\- Test archive(s).lnk');
end;

procedure clearcontext;
begin
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\+ Add to separate archive(s)');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\+ Add to separate .7Z');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\+ Add to separate .ZIP');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\+ Add to separate archive(s)');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\+ Add to separate .7Z');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\+ Add to separate .ZIP');
RegDeleteKeyIncludingSubkeys(HKCR, 'Directory\shell\- Browse with PeaZip');
//RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\+ Add to separate archive(s)');
//RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\+ Add to separate .7Z');
//RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\+ Add to separate .ZIP');
//RegDeleteKeyIncludingSubkeys(HKCR, 'Drive\shell\- Browse with PeaZip');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\+ Split file');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\+ Secure delete');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\- Extract here');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\- Extract...');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\- Extract here (in new folder)');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\- Open with PeaZip');
RegDeleteKeyIncludingSubkeys(HKCR, '*\shell\- Test archive(s)');
end;

procedure clearassociations;
begin
  if RegKeyExists(HKLM, 'SOFTWARE\PeaZip') then
    begin
    RegDeleteKeyIncludingSubkeys(HKLM, 'SOFTWARE\PeaZip');
    //7z
    RegDeleteValue(HKCR, '.7z', '');
    RegDeleteValue(HKCR, '7Z', '');
    RegDeleteValue(HKCR, '7Z\DefaultIcon', '');
    RegDeleteValue(HKCR, '7Z\shell\open\command', '');
    //ARC
    RegDeleteValue(HKCR, '.arc', '');
    RegDeleteValue(HKCR, 'ARC', '');
    RegDeleteValue(HKCR, 'ARC\DefaultIcon', '');
    RegDeleteValue(HKCR, 'ARC\shell\open\command', '');
    //WRC
    RegDeleteValue(HKCR, '.wrc', '');
    RegDeleteValue(HKCR, 'WRC', '');
    RegDeleteValue(HKCR, 'WRC\DefaultIcon', '');
    RegDeleteValue(HKCR, 'WRC\shell\open\command', '');
    //BZip2
    RegDeleteValue(HKCR, '.bz2', '');
    RegDeleteValue(HKCR, 'BZ2', '');
    RegDeleteValue(HKCR, 'BZ2\DefaultIcon', '');
    RegDeleteValue(HKCR, 'BZ2\shell\open\command', '');
    //GZip
    RegDeleteValue(HKCR, '.gz', '');
    RegDeleteValue(HKCR, 'GZ', '');
    RegDeleteValue(HKCR, 'GZ\DefaultIcon', '');
    RegDeleteValue(HKCR, 'GZ\shell\open\command', '');
    //LPAQ1
    RegDeleteValue(HKCR, '.lpaq1', '');
    RegDeleteValue(HKCR, 'LPAQ1', '');
    RegDeleteValue(HKCR, 'LPAQ1\DefaultIcon', '');
    RegDeleteValue(HKCR, 'LPAQ1\shell\open\command', '');
    //LPAQ5
    RegDeleteValue(HKCR, '.lpaq5', '');
    RegDeleteValue(HKCR, 'LPAQ5', '');
    RegDeleteValue(HKCR, 'LPAQ5\DefaultIcon', '');
    RegDeleteValue(HKCR, 'LPAQ5\shell\open\command', '');
    //LPAQ8
    RegDeleteValue(HKCR, '.lpaq8', '');
    RegDeleteValue(HKCR, 'LPAQ8', '');
    RegDeleteValue(HKCR, 'LPAQ8\DefaultIcon', '');
    RegDeleteValue(HKCR, 'LPAQ8\shell\open\command', '');
    //PAQ8F
    RegDeleteValue(HKCR, '.paq8f', '');
    RegDeleteValue(HKCR, 'PAQ8F', '');
    RegDeleteValue(HKCR, 'PAQ8F\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PAQ8F\shell\open\command', '');
    //PAQ8JD
    RegDeleteValue(HKCR, '.paq8jd', '');
    RegDeleteValue(HKCR, 'PAQ8JD', '');
    RegDeleteValue(HKCR, 'PAQ8JD\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PAQ8JD\shell\open\command', '');
    //PAQ8L
    RegDeleteValue(HKCR, '.paq8l', '');
    RegDeleteValue(HKCR, 'PAQ8L', '');
    RegDeleteValue(HKCR, 'PAQ8L\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PAQ8L\shell\open\command', '');
    //PAQ8O
    RegDeleteValue(HKCR, '.paq8o', '');
    RegDeleteValue(HKCR, 'PAQ8O', '');
    RegDeleteValue(HKCR, 'PAQ8O\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PAQ8O\shell\open\command', '');
    //QUAD
    RegDeleteValue(HKCR, '.quad', '');
    RegDeleteValue(HKCR, 'QUAD', '');
    RegDeleteValue(HKCR, 'QUAD\DefaultIcon', '');
    RegDeleteValue(HKCR, 'QUAD\shell\open\command', '');
    //BALZ
    RegDeleteValue(HKCR, '.balz', '');
    RegDeleteValue(HKCR, 'BALZ', '');
    RegDeleteValue(HKCR, 'BALZ\DefaultIcon', '');
    RegDeleteValue(HKCR, 'BALZ\shell\open\command', '');
    //Tar
    RegDeleteValue(HKCR, '.tar', '');
    RegDeleteValue(HKCR, 'TAR', '');
    RegDeleteValue(HKCR, 'TAR\DefaultIcon', '');
    RegDeleteValue(HKCR, 'TAR\shell\open\command', '');
    //TGZ
    RegDeleteValue(HKCR, '.tgz', '');
    RegDeleteValue(HKCR, 'TGZ', '');
    RegDeleteValue(HKCR, 'TGZ\DefaultIcon', '');
    RegDeleteValue(HKCR, 'TGZ\shell\open\command', '');
    //Zip
    RegDeleteValue(HKCR, '.zip', '');
    RegDeleteValue(HKCR, 'ZIP', '');
    RegDeleteValue(HKCR, 'ZIP\DefaultIcon', '');
    RegDeleteValue(HKCR, 'ZIP\shell\open\command', '');
    end;
  //delete additional filetype associations, if created by setup
  if RegKeyExists(HKLM, 'SOFTWARE\PeaZip_additional') then
    begin
    RegDeleteKeyIncludingSubkeys(HKLM, 'SOFTWARE\PeaZip_additional');
    //ACE
    RegDeleteValue(HKCR, '.ACE', '');
    RegDeleteValue(HKCR, 'ACE', '');
    RegDeleteValue(HKCR, 'ACE\DefaultIcon', '');
    RegDeleteValue(HKCR, 'ACE\shell\open\command', '');
    //ARJ
    RegDeleteValue(HKCR, '.ARJ', '');
    RegDeleteValue(HKCR, 'ARJ', '');
    RegDeleteValue(HKCR, 'ARJ\DefaultIcon', '');
    RegDeleteValue(HKCR, 'ARJ\shell\open\command', '');
    //CAB
    RegDeleteValue(HKCR, '.CAB', '');
    RegDeleteValue(HKCR, 'CAB', '');
    RegDeleteValue(HKCR, 'CAB\DefaultIcon', '');
    RegDeleteValue(HKCR, 'CAB\shell\open\command', '');
    //CPIO
    RegDeleteValue(HKCR, '.CPIO', '');
    RegDeleteValue(HKCR, 'CPIO', '');
    RegDeleteValue(HKCR, 'CPIO\DefaultIcon', '');
    RegDeleteValue(HKCR, 'CPIO\shell\open\command', '');
    //DEB
    RegDeleteValue(HKCR, '.DEB', '');
    RegDeleteValue(HKCR, 'DEB', '');
    RegDeleteValue(HKCR, 'DEB\DefaultIcon', '');
    RegDeleteValue(HKCR, 'DEB\shell\open\command', '');
    //DMG
    RegDeleteValue(HKCR, '.DMG', '');
    RegDeleteValue(HKCR, 'DMG', '');
    RegDeleteValue(HKCR, 'DMG\DefaultIcon', '');
    RegDeleteValue(HKCR, 'DMG\shell\open\command', '');
    //UDF
    RegDeleteValue(HKCR, '.HFS', '');
    RegDeleteValue(HKCR, 'HFS', '');
    RegDeleteValue(HKCR, 'HFS\DefaultIcon', '');
    RegDeleteValue(HKCR, 'HFS\shell\open\command', '');
    //ISO
    RegDeleteValue(HKCR, '.ISO', '');
    RegDeleteValue(HKCR, 'ISO', '');
    RegDeleteValue(HKCR, 'ISO\DefaultIcon', '');
    RegDeleteValue(HKCR, 'ISO\shell\open\command', '');
    //ISO
    RegDeleteValue(HKCR, '.UDF', '');
    RegDeleteValue(HKCR, 'UDF', '');
    RegDeleteValue(HKCR, 'UDF\DefaultIcon', '');
    RegDeleteValue(HKCR, 'UDF\shell\open\command', '');
    //LHA
    RegDeleteValue(HKCR, '.LHA', '');
    RegDeleteValue(HKCR, 'LHA', '');
    RegDeleteValue(HKCR, 'LHA\DefaultIcon', '');
    RegDeleteValue(HKCR, 'LHA\shell\open\command', '');
    //LZH
    RegDeleteValue(HKCR, '.LZH', '');
    RegDeleteValue(HKCR, 'LZH', '');
    RegDeleteValue(HKCR, 'LZH\DefaultIcon', '');
    RegDeleteValue(HKCR, 'LZH\shell\open\command', '');
    //PET
    RegDeleteValue(HKCR, '.PET', '');
    RegDeleteValue(HKCR, 'PET', '');
    RegDeleteValue(HKCR, 'PET\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PET\shell\open\command', '');
    //PUP
    RegDeleteValue(HKCR, '.PUP', '');
    RegDeleteValue(HKCR, 'PUP', '');
    RegDeleteValue(HKCR, 'PUP\DefaultIcon', '');
    RegDeleteValue(HKCR, 'PUP\shell\open\command', '');
    //RAR
    RegDeleteValue(HKCR, '.RAR', '');
    RegDeleteValue(HKCR, 'RAR', '');
    RegDeleteValue(HKCR, 'RAR\DefaultIcon', '');
    RegDeleteValue(HKCR, 'RAR\shell\open\command', '');
    //RPM
    RegDeleteValue(HKCR, '.RPM', '');
    RegDeleteValue(HKCR, 'RPM', '');
    RegDeleteValue(HKCR, 'RPM\DefaultIcon', '');
    RegDeleteValue(HKCR, 'RPM\shell\open\command', '');
    //SLP
    RegDeleteValue(HKCR, '.SLP', '');
    RegDeleteValue(HKCR, 'SLP', '');
    RegDeleteValue(HKCR, 'SLP\DefaultIcon', '');
    RegDeleteValue(HKCR, 'SLP\shell\open\command', '');
    //Z
    RegDeleteValue(HKCR, '.Z', '');
    RegDeleteValue(HKCR, 'Z', '');
    RegDeleteValue(HKCR, 'Z\DefaultIcon', '');
    RegDeleteValue(HKCR, 'Z\shell\open\command', '');
    end;
end;

function NextButtonClick(CurPageID: Integer): Boolean;
var
  ResultCode: Integer;
begin
if CurPageID = wpReady then
  begin

  clearcontext;
  clearlinks;

  //context menu items
  if cbcontextnone.state = cbUnchecked then
    begin
    if cbcontextadd2archive.state = cbChecked then
       begin
       RegWriteStringValue(HKCR, '*\shell\+ Add to separate archive(s)\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2archive" "%1"'));
       RegWriteStringValue(HKCR, 'Directory\shell\+ Add to separate archive(s)\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2archive" "%1"'));
       //RegWriteStringValue(HKCR, 'Drive\shell\+ Add to separate archive(s)\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2archive" "%1"'));
       end;
    if cbcontext7zs.state = cbChecked then
       begin
       RegWriteStringValue(HKCR, '*\shell\+ Add to separate .7Z\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separate7z" "%1"'));
       RegWriteStringValue(HKCR, 'Directory\shell\+ Add to separate .7Z\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separate7z" "%1"'));
       //RegWriteStringValue(HKCR, 'Drive\shell\+ Add to separate .7Z\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separate7z" "%1"'));
       end;
    if cbcontextzips.state = cbChecked then
       begin
       RegWriteStringValue(HKCR, '*\shell\+ Add to separate .ZIP\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separatezip" "%1"'));
       RegWriteStringValue(HKCR, 'Directory\shell\+ Add to separate .ZIP\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separatezip" "%1"'));
       //RegWriteStringValue(HKCR, 'Drive\shell\+ Add to separate .ZIP\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2separatezip" "%1"'));
       end;
    if cbcontextsplit.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\+ Split file\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2split" "%1"'));
    if cbcontextwipe.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\+ Secure delete\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-add2wipe" "%1"'));
    if cbcontextext2here.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\- Extract here\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2here" "%1"'));
    if cbcontextext2folder.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\- Extract here (in new folder)\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2folder" "%1"'));
    if cbcontext2to.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\- Extract...\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2full" "%1"'));
    if cbcontextopen.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\- Open with PeaZip\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2browse" "%1"'));
    if cbcontextbrowse.state = cbChecked then
       begin
       RegWriteStringValue(HKCR, 'Directory\shell\- Browse with PeaZip\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2browse" "%1"'));
       //RegWriteStringValue(HKCR, 'Drive\shell\- Browse with PeaZip\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2browse" "%1"'));
       end;
    if cbcontexttest.state = cbChecked then RegWriteStringValue(HKCR, '*\shell\- Test archive(s)\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "-ext2test" "%1"'));
    end;
    
  //link to PeaZip -add2archive: add to generic archive
  CreateShellLink(
  ExpandConstant('{sendto}\+ + Add to archive.lnk'),
  'PeaZip archiver, add to encrypted .pea archive',
  ExpandConstant('{app}\peazip.exe'),
  '-add2archive',
  '',
  '',
  0,
  SW_SHOWNORMAL);
  
  //link to PeaZip -ext2browse: open (and attempt to browse) archive content
  CreateShellLink(
  ExpandConstant('{sendto}\- - Open with PeaZip.lnk'),
  'PeaZip archiver, open archive',
  ExpandConstant('{app}\peazip.exe'),
  '-ext2browse',
  '',
  '',
  0,
  SW_SHOWNORMAL);
  
  if cbfunnone.state = cbUnchecked then
    begin
    
    //link to PeaZip -ext2here: extract here
    if cbfunext2here.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\- Extract here.lnk'),
      'PeaZip archiver, extract here',
      ExpandConstant('{app}\peazip.exe'),
      '-ext2here',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      4,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -ext2folder: extract here to new folder
    if cbfunext2folder.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\- Extract here (in new folder).lnk'),
      'PeaZip archiver, extract here to new folder',
      ExpandConstant('{app}\peazip.exe'),
      '-ext2folder',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      4,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -ext2to: extract to specified folder
    if cbfunext2to.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\- Extract....lnk'),
      'PeaZip archiver, extract into specified path',
      ExpandConstant('{app}\peazip.exe'),
      '-ext2full',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      4,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -add27z: add to .7z archive
    if cbfun7z.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to .7Z.lnk'),
      'PeaZip archiver, add to .7Z archive',
      ExpandConstant('{app}\peazip.exe'),
      '-add27z',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      2,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -add27zmail: add to .7z archive and send by mail
    if cbfun7zmail.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to .7Z and send by mail.lnk'),
      'PeaZip archiver, add to .7Z archive and send it by mail (Outlook)',
      ExpandConstant('{app}\peazip.exe'),
      '-add27zmail',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      3,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2separate7z: add to separate .7z archives
    if cbfun7zs.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to separate .7Z.lnk'),
      'PeaZip archiver, add to separate .7Z archives',
      ExpandConstant('{app}\peazip.exe'),
      '-add2separate7z',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      2,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2zip: add to .zip archive
    if cbfunzip.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to .ZIP.lnk'),
      'PeaZip archiver, add to .ZIP archive',
      ExpandConstant('{app}\peazip.exe'),
      '-add2zip',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      2,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2zipmail: add to .zip archive and send by mail
    if cbfunzipmail.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to .ZIP and send by mail.lnk'),
      'PeaZip archiver, add to .ZIP archive and send it by mail (Outlook)',
      ExpandConstant('{app}\peazip.exe'),
      '-add2zipmail',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      3,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -add2separatezip: add to separate .zip archives
    if cbfunzips.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to separate .ZIP.lnk'),
      'PeaZip archiver, add to separate .ZIP archives',
      ExpandConstant('{app}\peazip.exe'),
      '-add2separatezip',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      2,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -add2sfx7z: add to sfx 7z archive
    if cbfunsfx.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to self-extracting archive.lnk'),
      'PeaZip archiver, add to self extracting .7z archive',
      ExpandConstant('{app}\peazip.exe'),
      '-add2sfx7z',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      2,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2sfx7zmail: add to sfx 7z archive and send by mail
    if cbfunsfxmail.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Add to sfx and send by mail.lnk'),
      'PeaZip archiver, add to self extracting .7z archive and send it by mail (Outlook)',
      ExpandConstant('{app}\peazip.exe'),
      '-add2sfx7zmail',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      3,//icon index
      SW_SHOWNORMAL);
      end;
    
    //link to PeaZip -add2crypt: add to encrypted .pea archive
    if cbfunencrypt.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Encrypt.lnk'),
      'PeaZip archiver, add to encrypted .pea archive',
      ExpandConstant('{app}\peazip.exe'),
      '-add2crypt',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      0,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2split: raw file split
    if cbfunsplit.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Split file.lnk'),
      'PeaZip archiver, raw split single file',
      ExpandConstant('{app}\peazip.exe'),
      '-add2split',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      5,//icon index
      SW_SHOWNORMAL);
      end;
      
    //link to PeaZip -add2wipe: Secure delete
    if cbfunwipe.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\+ Secure delete.lnk'),
      'PeaZip archiver, secure delete',
      ExpandConstant('{app}\peazip.exe'),
      '-add2wipe',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      6,//icon index
      SW_SHOWNORMAL);
      end;

    //link to PeaZip -ext2test: test archive's content
    if cbfuntest.state = cbChecked then
      begin
      CreateShellLink(
      ExpandConstant('{sendto}\- Test archive(s).lnk'),
      'PeaZip archiver, list archive',
      ExpandConstant('{app}\peazip.exe'),
      '-ext2test',
      '',
      ExpandConstant('{app}\res\icons\peazip_new.icl'),//icon filename
      1,//icon index
      SW_SHOWNORMAL);
      end;
      
    end;
  clearassociations;
  BringToFrontAndRestore();
  if cbfullnone.state = cbUnchecked then
    begin
    //declare that filetype associations were created
    RegWriteStringValue(HKLM, 'SOFTWARE\PeaZip', '', 'Created filetype associations');
    //7z
    if cb7z.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.7z', '', '7Z');
      RegWriteStringValue(HKCR, '7Z', '', '7Z archive');
      RegWriteStringValue(HKCR, '7Z\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, '7Z\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //arc/wrc
    if cbarc.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.arc', '', 'ARC');
      RegWriteStringValue(HKCR, 'ARC', '', 'FreeARC archive');
      RegWriteStringValue(HKCR, 'ARC\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'ARC\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      RegWriteStringValue(HKCR, '.wrc', '', 'WRC');
      RegWriteStringValue(HKCR, 'WRC', '', 'FreeARC archive');
      RegWriteStringValue(HKCR, 'WRC\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'WRC\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //BZip2
    if cbbz2.state = cbChecked then
      begin
      //BZ
      RegWriteStringValue(HKCR, '.bz', '', 'BZ');
      RegWriteStringValue(HKCR, 'BZ', '', 'BZip2 compressed file');
      RegWriteStringValue(HKCR, 'BZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'BZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //BZ2
      RegWriteStringValue(HKCR, '.bz2', '', 'BZ2');
      RegWriteStringValue(HKCR, 'BZ2', '', 'BZip2 compressed file');
      RegWriteStringValue(HKCR, 'BZ2\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'BZ2\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //TBZ
      RegWriteStringValue(HKCR, '.tbz', '', 'TBZ');
      RegWriteStringValue(HKCR, 'TBZ', '', 'BZip2 compressed TAR archive');
      RegWriteStringValue(HKCR, 'TBZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TBZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //TBZ2
      RegWriteStringValue(HKCR, '.tbz2', '', 'TBZ2');
      RegWriteStringValue(HKCR, 'TBZ2', '', 'BZip2 compressed TAR archive');
      RegWriteStringValue(HKCR, 'TBZ2\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TBZ2\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //GZip
    if cbgz.state = cbChecked then
      begin
      //GZ
      RegWriteStringValue(HKCR, '.gz', '', 'GZ');
      RegWriteStringValue(HKCR, 'GZ', '', 'GZip compressed file');
      RegWriteStringValue(HKCR, 'GZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'GZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //TGZ
      RegWriteStringValue(HKCR, '.tgz', '', 'TGZ');
      RegWriteStringValue(HKCR, 'TGZ', '', 'GZip compressed TAR archive');
      RegWriteStringValue(HKCR, 'TGZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TGZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //PAQ/LPAQ group
    if cbpaq8.state = cbChecked then
      begin
      //LPAQ1
      RegWriteStringValue(HKCR, '.lpaq1', '', 'LPAQ1');
      RegWriteStringValue(HKCR, 'LPAQ1', '', 'LPAQ1 compressed file');
      RegWriteStringValue(HKCR, 'LPAQ1\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'LPAQ1\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //LPAQ5
      RegWriteStringValue(HKCR, '.lpaq5', '', 'LPAQ5');
      RegWriteStringValue(HKCR, 'LPAQ5', '', 'LPAQ5 compressed file');
      RegWriteStringValue(HKCR, 'LPAQ5\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'LPAQ5\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //LPAQ8
      RegWriteStringValue(HKCR, '.lpaq8', '', 'LPAQ8');
      RegWriteStringValue(HKCR, 'LPAQ8', '', 'LPAQ8 compressed file');
      RegWriteStringValue(HKCR, 'LPAQ8\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'LPAQ8\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PAQ8F
      RegWriteStringValue(HKCR, '.paq8f', '', 'PAQ8F');
      RegWriteStringValue(HKCR, 'PAQ8F', '', 'PAQ8F archive');
      RegWriteStringValue(HKCR, 'PAQ8F\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'PAQ8F\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PAQ8JD
      RegWriteStringValue(HKCR, '.paq8jd', '', 'PAQ8JD');
      RegWriteStringValue(HKCR, 'PAQ8JD', '', 'PAQ8JD archive');
      RegWriteStringValue(HKCR, 'PAQ8JD\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'PAQ8JD\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PAQ8L
      RegWriteStringValue(HKCR, '.paq8l', '', 'PAQ8L');
      RegWriteStringValue(HKCR, 'PAQ8L', '', 'PAQ8L archive');
      RegWriteStringValue(HKCR, 'PAQ8L\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'PAQ8L\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PAQ8O
      RegWriteStringValue(HKCR, '.paq8o', '', 'PAQ8O');
      RegWriteStringValue(HKCR, 'PAQ8O', '', 'PAQ8O archive');
      RegWriteStringValue(HKCR, 'PAQ8O\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'PAQ8O\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    if cbquad.state = cbChecked then
      begin
      //QUAD
      RegWriteStringValue(HKCR, '.quad', '', 'QUAD');
      RegWriteStringValue(HKCR, 'QUAD', '', 'QUAD compressed file');
      RegWriteStringValue(HKCR, 'QUAD\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'QUAD\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //BALZ
      RegWriteStringValue(HKCR, '.balz', '', 'BALZ');
      RegWriteStringValue(HKCR, 'BALZ', '', 'BALZ compressed file');
      RegWriteStringValue(HKCR, 'BALZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'BALZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //Tar
    if cbtar.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.tar', '', 'TAR');
      RegWriteStringValue(HKCR, 'TAR', '', 'TAR archive');
      RegWriteStringValue(HKCR, 'TAR\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TAR\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //Zip
    if cbzip.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.zip', '', 'ZIP');
      RegWriteStringValue(HKCR, 'ZIP', '', 'ZIP archive');
      RegWriteStringValue(HKCR, 'ZIP\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'ZIP\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    end;
  if cbreadnone.state = cbunchecked then
    begin //associate types with browse/extract only support
    //declare that additional filetype associations were created
    RegWriteStringValue(HKLM, 'SOFTWARE\PeaZip_additional', '', 'Created additional filetype associations');
    //ACE
    if cbace.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.ACE', '', 'ACE');
      RegWriteStringValue(HKCR, 'ACE', '', 'ACE archive');
      RegWriteStringValue(HKCR, 'ACE\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'ACE\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //ARJ
    if cbarj.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.ARJ', '', 'ARJ');
      RegWriteStringValue(HKCR, 'ARJ', '', 'ARJ archive');
      RegWriteStringValue(HKCR, 'ARJ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'ARJ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //CAB
    if cbcab.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.CAB', '', 'CAB');
      RegWriteStringValue(HKCR, 'CAB', '', 'CAB archive');
      RegWriteStringValue(HKCR, 'CAB\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'CAB\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //CPIO
    if cbcpio.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.CPIO', '', 'CPIO');
      RegWriteStringValue(HKCR, 'CPIO', '', 'CPIO archive');
      RegWriteStringValue(HKCR, 'CPIO\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'CPIO\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //Z
      RegWriteStringValue(HKCR, '.Z', '', 'Z');
      RegWriteStringValue(HKCR, 'Z', '', 'Z compressed file');
      RegWriteStringValue(HKCR, 'Z\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'Z\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //TZ
      RegWriteStringValue(HKCR, '.tz', '', 'TZ');
      RegWriteStringValue(HKCR, 'TZ', '', 'Z compressed TAR archive');
      RegWriteStringValue(HKCR, 'TZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //TZ
      RegWriteStringValue(HKCR, '.taz', '', 'TAZ');
      RegWriteStringValue(HKCR, 'TAZ', '', 'Z compressed TAR archive');
      RegWriteStringValue(HKCR, 'TAZ\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'TAZ\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //Disk images
    if cbiso.state = cbChecked then
      begin
      //ISO
      RegWriteStringValue(HKCR, '.ISO', '', 'ISO');
      RegWriteStringValue(HKCR, 'ISO', '', 'ISO disk image');
      RegWriteStringValue(HKCR, 'ISO\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_CD.ICO,0'));
      RegWriteStringValue(HKCR, 'ISO\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //UDF
      RegWriteStringValue(HKCR, '.UDF', '', 'UDF');
      RegWriteStringValue(HKCR, 'UDF', '', 'UDF disk image');
      RegWriteStringValue(HKCR, 'UDF\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_CD.ICO,0'));
      RegWriteStringValue(HKCR, 'UDF\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //LHA
    if cblha.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.LHA', '', 'LHA');
      RegWriteStringValue(HKCR, 'LHA', '', 'LHA archive');
      RegWriteStringValue(HKCR, 'LHA\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'LHA\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //Linux packages (DEB, RPM, PET/PUP)
    if cblinux.state = cbChecked then
      begin
      //DEB
      RegWriteStringValue(HKCR, '.DEB', '', 'DEB');
      RegWriteStringValue(HKCR, 'DEB', '', 'DEB package');
      RegWriteStringValue(HKCR, 'DEB\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'DEB\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PET
      RegWriteStringValue(HKCR, '.PET', '', 'PET');
      RegWriteStringValue(HKCR, 'PET', '', 'PET package (Puppy Linux)');
      RegWriteStringValue(HKCR, 'PET\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'PET\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //PUP
      RegWriteStringValue(HKCR, '.PUP', '', 'PUP');
      RegWriteStringValue(HKCR, 'PUP', '', 'PUP package (Puppy Linux)');
      RegWriteStringValue(HKCR, 'PUP\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'PUP\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //RPM
      RegWriteStringValue(HKCR, '.RPM', '', 'RPM');
      RegWriteStringValue(HKCR, 'RPM', '', 'RPM package');
      RegWriteStringValue(HKCR, 'RPM\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'RPM\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //SLP
      RegWriteStringValue(HKCR, '.SLP', '', 'SLP');
      RegWriteStringValue(HKCR, 'SLP', '', 'SLP package');
      RegWriteStringValue(HKCR, 'SLP\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'SLP\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //LZH
    if cblzh.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.LZH', '', 'LZH');
      RegWriteStringValue(HKCR, 'LZH', '', 'LZH archive');
      RegWriteStringValue(HKCR, 'LZH\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'LZH\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //Mac formats (DMG, HFS)
    if cbMac.state = cbChecked then
      begin
      //DMG
      RegWriteStringValue(HKCR, '.DMG', '', 'DMG');
      RegWriteStringValue(HKCR, 'DMG', '', 'DMG package');
      RegWriteStringValue(HKCR, 'DMG\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'DMG\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      //UDF
      RegWriteStringValue(HKCR, '.HFS', '', 'HFS');
      RegWriteStringValue(HKCR, 'HFS', '', 'UDF package');
      RegWriteStringValue(HKCR, 'HFS\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP_PACKAGE.ICO,0'));
      RegWriteStringValue(HKCR, 'HFS\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    //RAR
    if cbrar.state = cbChecked then
      begin
      RegWriteStringValue(HKCR, '.RAR', '', 'RAR');
      RegWriteStringValue(HKCR, 'RAR', '', 'RAR archive');
      RegWriteStringValue(HKCR, 'RAR\DefaultIcon', '', ExpandConstant('{app}\RES\ICONS\PEAZIP.ICO,0'));
      RegWriteStringValue(HKCR, 'RAR\shell\open\command', '', ExpandConstant('"{app}\PEAZIP.EXE" "%1"'));
      end;
    end;
  BringToFrontAndRestore();
  end;
Result := True;
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
if CurUninstallStep = usDone then
  begin
  clearlinks; //delete links
  clearcontext; //delete context menu items
  clearassociations; //delete filetype associations (by read/write and/or read only group), if created by previous setup
  BringToFrontAndRestore();
  end;
end;
